<template>
    <div class="inButcherHurdle">
        <h2 style="margin-bottom: 20px;padding-bottom:7px;border-bottom:2px solid #ddd">入宰登记</h2>
        <header id="header">
            <el-row type="flex" :gutter="20">
                <el-col :span="4">
                    <el-input v-model="search" placeholder="请选择"></el-input>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="getWaitList">查找</el-button>
                </el-col>
                <el-col :span="4">
                    <el-button type="primary" @click="add">新增</el-button>
                </el-col>
            </el-row>
        </header>
        <section>
            <article class="table">
                <el-table
                    ref="multipleTable"
                    :data="tableData"
                    tooltip-effect="dark"
                    style="width: 100%"
                >
                    <el-table-column prop="id" label="序号" width="80"></el-table-column>
                    <el-table-column prop="sheepId" label="羊只编号" width="180"></el-table-column>
                    <el-table-column prop="entryTime" label="入栏时间" width="180"></el-table-column>
                    <el-table-column prop="currentPosition" label="目前位置" width="180"></el-table-column>
                    <el-table-column prop="operator" label="操作人员"></el-table-column>
                    <el-table-column prop="batchNo" label="批次号"></el-table-column>
                    <el-table-column label="操作" width="150">
                        <template slot-scope="scope">
                            <el-button @click="edit(scope.row)" type="text" size="small">编辑</el-button>
                            <el-popconfirm title="是否删除此设备的信息？" @onConfirm="del(scope.row)">
                                <el-button slot="reference" type="text" size="small">删除</el-button>
                            </el-popconfirm>
                        </template>
                    </el-table-column>
                </el-table>

                <el-row type="flex" justify="end">
                    <el-col :span="8" class="pagination">
                        <el-pagination
                            @current-change="pageChange"
                            background
                            layout="prev, pager, next"
                            :page-count="Number(totalPages)"
                        ></el-pagination>
                    </el-col>
                </el-row>
            </article>
        </section>

        <el-dialog title="新增种羊档案" :visible.sync="isShow" width="40%">
            <el-row type="flex">
                <el-col :span="20">
                    <el-form ref="addWait" :model="formData" :rules="rules" label-width="140px">
                        <el-form-item label="羊只编码">
                            <el-input v-model="formData.sheepId"></el-input>
                        </el-form-item>

                        <el-form-item label="入栏时间">
                            <el-date-picker
                                v-model="formData.entryTime"
                                type="date"
                                value-format="yyyy-MM-dd"
                                placeholder="选择日期"
                            ></el-date-picker>
                        </el-form-item>

                        <el-form-item label="送检人员">
                            <el-input v-model="formData.operator"></el-input>
                        </el-form-item>

                        <el-form-item label="目前位置">
                            <el-input v-model="formData.currentPosition"></el-input>
                        </el-form-item>

                        <el-form-item label="批次号">
                            <el-input v-model="formData.batchNo"></el-input>
                        </el-form-item>

                        <el-form-item>
                            <el-button @click="isShow=false">取 消</el-button>
                            <el-button type="primary" @click="submitForm('addWait')">保 存</el-button>
                        </el-form-item>
                    </el-form>
                </el-col>
            </el-row>
        </el-dialog>
    </div>
</template>

<script>
import {
    reqWaitList,
    reqAddWait,
    reqUpdateWait,
    reqDelWait
} from "@/api/slaughterManagment.js";

const pageSize = 10;
const rules = {};

export default {
    name: "inButcherHurdle",
    data() {
        return {
            search: "",
            page: 1,
            tableData: [],
            totalPages: 0,
            isShow: false,
            formData: {
                sheepId: "1008",
                entryTime: this.$moment().format("YYYY-MM-DD"),
                operator: "王炸",
                currentPosition: "待宰栏一舍01",
                batchNo: '1396'
            },
            isAdd: false,
            rules
        };
    },
    created() {
        // 入待宰栏列表
        this.getWaitList();
    },
    methods: {
        submitForm(formName) {
            this.$refs[formName].validate(valid => {
                if (valid) {
                    if (this.isAdd) {
                        reqAddWait(this.formData)
                            .then(res => {
                                // 入待宰栏列表
                                this.getWaitList();
                                this.$message.success("添加成功！");
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("添加失败！");
                            });
                    } else {
                        reqUpdateWait(this.formData)
                            .then(res => {
                                // 入待宰栏列表
                                this.getWaitList();
                                this.$message.success("编辑成功！");
                            })
                            .catch(err => {
                                console.log(err);
                                this.$message.error("编辑失败！");
                            });
                    }
                } else {
                    return false;
                }
            });
        },
        // 入待宰栏列表 
        getWaitList() {
            reqWaitList({
                searchStr: this.search,
                pageSize,
                pageNum: this.page
            })
                .then(res => {
                    this.tableData = res.content;
                    this.totalPages = res.totalPages;
                })
                .catch(err => {
                    console.log(err);
                });
        },
        add() {
            this.isShow = true;
            this.isAdd = true
        },
        edit(row) {
            this.formData = row;
            this.isShow = true;
            this.isAdd = false
        },
        del(row) {
            reqDelWait(row.id)
                .then(res => {
                    console.log(res);
                    // 入待宰栏列表
                    this.getWaitList();
                    this.$message.success("删除成功！");
                })
                .catch(err => {
                    console.log(err);
                    this.$message.error("删除失败！");
                });
        },
        pageChange(p) {
            console.log(p);
            this.page = p;
            // 入待宰栏列表
            this.getWaitList();
        }
    }
};
</script>

<style lang="scss" scoped>
#header {
    margin-bottom: 15px;
}
.table {
    .pagination {
        margin-top: 20px;
    }
}
</style>